/*
 *	G	df
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-202: LED DOT MATRIX
 *
 *		ڑ
 *			ADM-001				ADM-203
 *			RB0					P1
 *			RB1					P2
 *			RB2					P3
 *			RB3					P4
 *			RB4					P5
 *			RB5					P6
 *			RB6					P7
 *			RB7					P8
 *
 *			Vcc					P9
 *
 *			RA0					P10
 *			RA1					P11
 *			RA2					P12
 *			RA3					P13
 *			RA4					P14
 *
 *			Vcc					P15
 *			Vcc					P16
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	}N`
 */
#define	CCPR1_VAL		1000L							// 1mbƂɊޏꍇCCPR1ɑl
#define	LED_ALL_OFF		PORTB=0x00,PORTA|=0b00011111	// LED DOT MATRIXׂď
#define	MAX_CODE		36								// R[hpz̗vf

/*
 	O[oϐ
 */
// R[hpz
// LED DOT MATRIX̃Am[h ( PORTB )񂸂HxɂȂC
// RA0`RA4ɂ̔z̒li[
const unsigned char a_code[MAX_CODE] = {
	0b00000, 0b11110, 0b01001, 0b01001, 0b11110, 0b00000,		// A
	0b00000, 0b11111, 0b10101, 0b10101, 0b01010, 0b00000,		// B
	0b00000, 0b01110, 0b10001, 0b10001, 0b01010, 0b00000,		// C
	0b00000, 0b11111, 0b10001, 0b10001, 0b01110, 0b00000,		// D
	0b00000, 0b11111, 0b10101, 0b10101, 0b10001, 0b00000,		// E
	0b00000, 0b11111, 0b00101, 0b00101, 0b00001, 0b00000,		// F
};


/*
	main
 */
void main( void ){

	/*	|[g	*/	
	CMCON = 0x07;						// RA0`RA3 <- IO
	LED_ALL_OFF;						// LED DOT MATRIX 
	TRISA = 0b00100000;					// RA0`RA4,RA6`RA7 <- outport
	TRISB = 0x00;						// PORTB             <- outport



	/*	CCPݏ 1msƂɊ	*/
	CCP1CON = 0b00001011;				// CCP݃[h

	CCPR1H  = ( 0b0000001111101000 >> 8 );		// CCPR1H <- CCPR1_BAL̏8rbg
	CCPR1L  = ( CCPR1_VAL & 0x00FF );	// CCPR1L <- CCPR1_BAL̉8rbg

	CCP1IF = 0;							// CCP݃tONA
	CCP1IE = 1;							// CCP݂̋

	
	/*	Timer1	*/
	TMR1ON = 1;
	TMR1CS = 0;							// NbNNbNɐݒ
	
	T1CKPS1 = 0;						// /1
	T1CKPS0 = 0;

	TMR1H = 0;							// TMRWX^NA
	TMR1L = 0;
	
	/*	݋	*/
	PEIE = 1;							// Ӌ@\݋
	GIE = 1;							// ݑS̋

	while(1)
		;

}


/*
	݃T[rX[`
		1mbƂCCP
 */
static void __interrupt() isr(void){

	static unsigned int cnt = 0;			// 500mbƂɕ𗬂߂̕ϐ
	static unsigned int index = 0;			// LED DOT MATRIX ̕\wp 0(1:ԍ)`7(8:ԉE)
	static unsigned int codeIndex = 0;		//  A`F ̂ǂ\邩wp
	
	
	/*	_Ci~bN_	*/
	PORTB =  ( 0x01 << index );		// _Ci~bN_FLED DOT MATRIXP1`P8Hxɐݒ

	// F̎A\
	if( ( codeIndex + index ) > ( MAX_CODE - 1 ) ){
		PORTA = ~a_code[codeIndex+index-MAX_CODE];
	}
	else{
		PORTA = ~a_code[codeIndex+index];
	}

	index++;							// Eɂ炷
	if( index > 7 ){
		index = 0;						// ԉE܂ōsԍɖ߂
	}


	/* 	_p^[̕ύX	*/
	if ( cnt > 500 ){
		if( ++codeIndex > ( MAX_CODE - 1 ) ){
			codeIndex = 0;				// F̈ԍŌ܂ŕ\A̓ɖ߂
		}
		cnt = 0;
	}
	else{
		cnt++;
	}	

	CCP1IF = 0;	// CCP݃tONA

}


