/*
 *	G	LED
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-201: LED
 *			ADM-106: VOLUME
 *
 *		ڑ
 *			ADM-001				ADM-201
 *			CCP1 ( RB3 )		P1
 *
 *			ADM-001				ADM-106
 *			AN0 ( RA0 )			P1
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
int getAnalogV( void );		// ADϊ


/*
	O[oϐ
 */

// ADϊ̌ʂɂCCPR1Lɑlz
// @vfύXɂLED邳
const unsigned int a_ccpr1l[16] = {
	//240, 200, 180, 160, 140, 120, 100, 80, 70,  60,  50,  40,  30,  20,  10,  5
	249, 249, 180, 160, 140, 120, 100, 80, 70,  60,  50,  40,  25,  10,  5,  2
};


/*
	main֐
 */

void main( void ){

	/*	|[g	*/
	TRISA = 0xff;			// PORTA <- input
	TRISB = 0x00;			// PORTB <- output
	CMCON = 0b00000010;		// AN0`AN3L
	
	VRCON = 0b10100000;		// AiOERp[^ݒ
	
	/*	PWM[h	*/
	CCP1M3 = 1;		// PWM[hɐݒ
	CCP1M2 = 1;
	CCP1M1 = 0;
	CCP1M0 = 0;

	PR2 = 249;		// PWM pXF1000us   <- i 249 + 1 ) * 4us

	CCPR1L = 0;
	CCP1X  = 0;
	CCP1Y  = 0;


	/*	Timer2	*/
	T2CKPS1 = 0;	// /4
	T2CKPS0 = 1;
	TMR2    = 0;
	
	TMR2ON  = 1;	// Timer2 Start


	/*	Timer0	*/
	T0CS = 0;		// NbNNbNɐݒ

	PSA  = 0;		// vXP[^C}0Ɋ蓖
	PS2  = 0;		// /2
	PS1  = 0;
	PS0  = 0;

	TMR0 = 0x00;	// TMR0WX^NA

	T0IF = 0;		// ^C}0݃tONA
	T0IE = 1;		// ^C}0݂̋


	GIE = 1;		// ݑŜ̋

	while(1)
		;
}


/*
	ADϊ
		߂l : VRCON̉4rbg
 */
int getAnalogV( void ){

	VRCON = 0b10000000;		// VRCON̉4rbgFd 0V

	// C1OUT1ɂȂ܂Ń[v
	//	-> AN0̓ddȏɂȂ܂Ń[v
	while( C1OUT != 1 ){
		VRCON++;					// dύX
	}

	return( VRCON&0x0F );
}

/*
	݃T[rX[`
		512ubƂɃ^C}
 */
static void interrupt isr()
{
	static int cnt = 0;		// ݉񐔃JEg
	int ad;					// ADϊʊi[

	// ݂20񂲂ƂADϊ
	//		512us ~ 20  10ms
	if( cnt > 20 ){

		ad = getAnalogV();			// ADϊ

		CCPR1L = a_ccpr1l[ad];		// PWM HADϊʂɂĐݒ
		CCP1X = 0;
		CCP1Y = 0;

		cnt = 0;					// ݉񐔁@
	}
	else{
		cnt++;						// ݉ + 1
	}

	
	T0IF = 0;						// ^C}0݃tONA
}
