/*
 *	G	Lb`^C}
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-203: 7SEGMENT LED
 *			ADM-101: PUSH SWITCH
 *
 *		ڑ
 *			ADM-001				ADM-203
 *			RB0					P4
 *			RB1					P3
 *			RB2					P2
 *			RB3					P1
 *			RB4					P5
 *			RB5					P6
 *			RB6					P7
 *			RB7					P8
 *
 *			ADM-001				ADM-101
 *			RA0					P1
 *			RA1					P2
 *			RA2					P3
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>

/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void set7Seg( unsigned int num, unsigned int id );		// idŎw肵7SEG LEDɐ\
void dispTimer( void );									// ^C}\
void setTimer( void );									// ݒ
void Beep (int cnt);
void WaitTime (int cnt);

/*
	}N`
 */
#define	CCPR1_VAL		1000L	// 1mbƂɊޏꍇCCPR1ɑl

#define	STATE_SET_TIM	0		// ^C}Zbg
#define	STATE_TIMER		1		// ^C}
#define	STATE_STOP		2		// ^C}~
#define	STATE_BEEP		3		// JEg_EO

#define	SW_SEC			RA0		// "b"킹pSW
#define	SW_MIN			RA1		// ""킹pSW
#define	SW_START		RA2		// START SW

#define	SW_ON			0
#define	SW_OFF			1



/*
 	O[oϐ
 */
int g_ms  = 0;							// o "mb" i[
int g_sec = 0;							// c "b" i[
int g_min = 0;							// c "" i[
unsigned int g_state;					// vOԕϐ


/*
	main
 */
void main( void ){

	/*	|[g	*/	
	CMCON = 0x07;						// RA0`RA3 <- IO
	PORTB = 0x00;						// PORTB    <- Lx
	TRISB = 0x00;						// PORTB    <- outport
	TRISA = 0b00100111;					// RA0`RA2 <- inport

	
	/*	CCPݏ 1msƂɊ	*/
	CCP1CON = 0b00001011;				// CCP݃[h
	CCPR1H  = ( CCPR1_VAL >> 8 );		// CCPR1H <- CCPR1_VAL̏8rbg
	CCPR1L  = ( CCPR1_VAL & 0x00FF );	// CCPR1L <- CCPR1_VAL̉8rbg

	CCP1IF  = 0;						// CCP݃tONA
	CCP1IE  = 1;						// CCP݂̋

	
	/*	Timer1	*/
	TMR1ON  = 0;						// Timer1 Stop
	TMR1CS  = 0;						// NbNNbNɐݒ
	
	T1CKPS1 = 0;						// /1
	T1CKPS0 = 0;

	TMR1H   = 0;							// TMRWX^NA
	TMR1L   = 0;
	
	/*	݋	*/
	PEIE = 1;							// Ӌ@\݋
	GIE  = 1;							// ݑS̋


	g_state = STATE_SET_TIM;			// vOԕϐ <- ^C}Zbg

	while(1){
		
		// vOԕϐg_stateɂ菈
		switch ( g_state ){
			
			// ^C}Zbg
			case STATE_SET_TIM:{
				
				// START SWꂽꍇ
				if( SW_START == SW_ON ){
						TMR1ON = 1;					// Timer1 Start
						g_state = STATE_TIMER;		// "^C}"ɑJ
				}
				else{
					setTimer();						// ^C}Zbg
				}
				break;
			}
			// ^C}
			case STATE_TIMER:{
				/*
					uSW^C}~vȂǂ̏ǉꍇ́C
					ɋLq
				 */
				break;
			}
			// ^C}~
			case STATE_STOP:{

				TMR1ON = 0;					// Timer1 Stop

				g_min = 0;					// ^C}ԃNA
				g_sec = 0;					// ^C}ԃNA
				g_ms  = 0;					// ^C}ԃNA

				g_state = STATE_SET_TIM;	// "^C}Zbg"ɑJ

				break;
			}
			// JEg_E^C}O@Beep
			case STATE_BEEP:{
				Beep(1);
				g_state = STATE_STOP;		// "^C}~"ɑJ
			}
		}
		
		
		dispTimer( );
	}
	
}




/*
	117SEGɐZbg

	
		num : Zbg鐔 ( l )
		id	: 0 -> "" 2
		      1 -> "" 1
		      2 -> "b" 2
		      3 -> "b" 1
*/
void set7Seg( unsigned int num, unsigned int id ){

	PORTB = ( ( 0b00001000 >> id ) | ( num << 4 ) );
}	

/*
	^C}\
 */
void dispTimer( void ){

	set7Seg( g_min / 10, 0 );		// "" 2 \
	set7Seg( g_min % 10, 1 );		// "" 1 \

	set7Seg( g_sec / 10, 2 );		// "b" 2 \
	set7Seg( g_sec % 10, 3 );		// "b" 1 \

}

/*
	^C}Zbg
 */
void setTimer( void ){
	
	static int cnt = 0;		// Aă^C}ԕύXsȂ悤ɒ邽߂̕ϐ
	
	// Aă^C}ԕύXsȂ悤ɕϐcntŒ
	if( cnt < 1 ){

		// "b"킹pSWꂽꍇ
		if( SW_SEC == SW_ON ){
			g_sec++;					// "b" + 1

			if( g_sec > 59 ){
				g_sec=0;				// "60b"̏ꍇ"0b"ɖ߂
			}
			cnt = 100;
		}
		// ""킹pSWꂽꍇ
		if( SW_MIN == SW_ON ){
			g_min++;					// "" + 1

			if( g_min > 99 ){
				g_min=0;				// "100"̏ꍇ"0"ɖ߂
			}
			cnt = 100;
		}
	}
	else{
		cnt--;							// Aă^C}ԕύXsȂ悤ɕϐcntŒ
	}
}




/*
	݃T[rX[`
		1mbƂCCP
 */
static void __interrupt() isr(void){

	g_ms++;		// o "mb" + 1

	// ^C}0ɂȂꍇ
	if( g_min < 1 && g_sec < 1 ){
		g_state = STATE_BEEP;		// "JEg_E^C}O"ɑJ
		//g_state = STATE_STOP;		// "^C}~"ɑJ
	}
	else {
		// 1000mbo߂ꍇ
		if( g_ms >= 1000 ){
			g_sec--;				// c "b" - 1
			
			// c "b" 0菬ꍇ
			if( g_sec < 0 ){
				g_min--;			// c "" - 1
				g_sec = 59;			// c "b"59bɖ߂
			}

			g_ms = 0;
		}
	}	
	

	CCP1IF = 0;	// CCP݃tONA
}


// r[v

void Beep(int bcnt)
{
	while(bcnt > 0)
		bcnt--;
		RA3 = ~RA3;
		// 
		WaitTime(20);
}



// ҂Ԋ֐̌Ăяo
void WaitTime(int wcnt)
{
	while(wcnt > 0)
		wcnt--;
}